# #!/usr/bin/perl -w

## Posted by Groo to forums.baldursgate.com 06/17/13 ##

###################################
##  IGNORE THESE PERL CONSTRUCTS ##
###################################
use strict;
use File::Copy;
use File::Copy::Recursive qw(fcopy rcopy dircopy fmove rmove dirmove);





####################################################
## Change these paths to your relevant paths      ##
## Note the esapes for \ character (\\ acts as \) ##
####################################################
my $localSavePath="D:\\My Documents\\Baldur's Gate - Enhanced Edition\\save\\"; #This is where you are copying your saves from
my $cloudSavePath="D:\\My Documents\\Dropbox\\Misc\\Baldur\\";                  #This is where you are copying your saves to  






#######################################################################
## SHOULDN'T NEED TO EDIT BELOW HERE ##
#######################################

opendir(DIR,$localSavePath) or die "\n ERROR: cannot open directory $localSavePath: $!"; #open the local save directory

my $dir = "";                           # holds the name of the save directory without the path
my @dirNames;                           # holds the list of save directory names

# this capture all the save directory names and put them in the array @dirNames
while (defined($dir = readdir(DIR))) {
  next if $dir =~ /^\.\.?$/o;           # skip "." and ".."
  next if (! -d $localSavePath.$dir);   # skip anything that's not a directory
  push (@dirNames,$dir);                # add the directory name to the array
}
closedir(DIR);                          # close the local directory

# this steps through each directory and copys it from local to cloud
# if the directory already exists, it creates a backup
my $cnt = 0;                            # counter to track how many backups there are
foreach $dir (@dirNames) {
  $cnt = 0;                             # reset counter to track how many backups there are
  my $saveDir = $dir;                   # will be the directory used for the most recent copy
  while (-d $cloudSavePath.$dir) {      # keep renaming the backup directory until we find one that doesn't exist yet
     $dir = $saveDir.".bak.".$cnt;      # create a tempory backup directory name
     $cnt++;                            # move the counter
  }

  my ($numFilesDirs,$numDirs,$depthTraversed) = (0,0,0); #mostly unnecesary variable init
  if ($cnt > 0) {
    my ($numFilesDirs,$numDirs,$depthTraversed) = dirmove($cloudSavePath.$saveDir,$cloudSavePath.$dir);   #do the actual move
  }
  my ($numFilesDirs,$numDirs,$depthTraversed) = dircopy($localSavePath.$saveDir,$cloudSavePath.$saveDir); #do the actual copy
}

exit(0);
##############
## END MAIN ##
#######################################################################
